/************************************************************************/
/*									*/
/*			Clock / Calendar				*/
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/

#include "main.h"
#include "clock.h"
#include "timerint.h"


u8 second, minute, hour;

u8 numbers[] = { _0, _1, _2, _3, _4, _5, _6, _7, _8, _9 };


u8 get7s( u8 val )
{
  return numbers[val];
}


void display_time( u8 set )
{
  u8 t = sec_timer >> 8;		// high byte only

  if( t < (INTTIME >> 9) )		// 1/2 second
    set = 0;

  if( set == 1 ){
    digit[3] = 0;
    digit[2] = 0;
  }else{
    digit[3] = get7s( hour / 10);
    digit[2] = get7s( hour % 10);
  }
  if( set == 2 ){
    digit[1] = 0;
    digit[0] = 0;
  }else{
    digit[1] = get7s( minute / 10);
    digit[0] = get7s( minute % 10);
  }
}


void clock(void)
{
  second++;
  if( second == 60 ){
    second = 0;
    minute++;
    if( minute == 60 ){
      minute = 0;
      hour++;
      if( hour == 24 )
        hour = 0;
    }
  }
}

