#include "main.h"
#include "timerint.h"
#include "getkey.h"


u8 get_key_press( u8 key_mask )
{
  cli();					// read and clear atomic !
  key_mask &= key_press;                        // read key(s)
  key_press ^= key_mask;                        // clear key(s)
  sei();
  return key_mask;
}


u8 get_key_rpt( u8 key_mask )
{
  cli();					// read and clear atomic !
  key_mask &= key_rpt;                        	// read key(s)
  key_rpt ^= key_mask;                        	// clear key(s)
  sei();
  return key_mask;
}


u8 get_key_num( void )
{
  u8 i = 0;

  if( get_key_press( 1<<KEY0 ))
    i = KEY_LEFT_SHORT;

  if( get_key_press( 1<<KEY1 ))
    i = KEY_RIGHT_SHORT;

  if( get_key_rpt( 1<<KEY0 ))
    i = KEY_LEFT_LONG;

  if( get_key_rpt( 1<<KEY1 ))
    i = KEY_RIGHT_LONG;

  return i;
}
