#include "main.h"
#include "timerint.h"
#include "clock.h"
#include "getkey.h"


		// logarithmic brightness table:

u8 BRIGHT[] = { 8, 11, 16, 23, 32, 45, 64, 90, 127, 180, 255 };


#define STATE_CLOCK	  0
#define STATE_SET_HOUR	  5
#define STATE_SET_MINUTE 10


int main( void )
{
  u8 state = STATE_CLOCK;
  u8 flash;
  u8 bright = sizeof(BRIGHT) - 1;

  PORTA = 0xFF;				// pull ups on
  PORTB = 0xFF;

  DISDDR  = 1<<DIG0^1<<DIG1^1<<DIG2^1<<DIG3^1<<DISCLK^1<<DISDAT;

  TCCR1A = 0x00;
  TCCR1B = 1<<CS12;			// 11.0592MHz / 8 / 256 = 5.4kHz
  TIMSK = 1<<OCIE1B^1<<TOIE1;
  OCR1B = BRIGHT[bright];
  sei();

  for(;;){
    flash = 0;
    switch( state + get_key_num() ){	// control state machine

      case STATE_CLOCK + KEY_LEFT_SHORT:
	if( bright < sizeof(BRIGHT) - 1 )
	  bright++;
	OCR1B = BRIGHT[bright];
	break;

      case STATE_CLOCK + KEY_RIGHT_SHORT:
	if( bright )
	  bright--;
	OCR1B = BRIGHT[bright];
	break;

      case STATE_CLOCK + KEY_LEFT_LONG:
      case STATE_SET_HOUR + KEY_LEFT_SHORT: 
        state += 5;
	break;

      case STATE_SET_MINUTE + KEY_LEFT_SHORT:
	state = STATE_CLOCK;
	break;

      case STATE_SET_HOUR:
	flash = 1;			// flash hour
	break;

      case STATE_SET_MINUTE:
	flash = 2;			// flash minute
	break;

      case STATE_SET_HOUR + KEY_RIGHT_SHORT:
      case STATE_SET_HOUR + KEY_RIGHT_LONG:
        hour++;
        if( hour == 24 )
          hour = 0;
        break;        

      case STATE_SET_MINUTE + KEY_RIGHT_SHORT:
      case STATE_SET_MINUTE + KEY_RIGHT_LONG:
	second = 0;
	minute++;
	if( minute == 60 )
	  minute = 0;
        break;        
    }
    if( one_second ){
      one_second = 0;
      clock();
    }
    if( key_state & 1<<KEY1 )
      flash = 0;			// no flash, if right key pressed
    display_time( flash );
  }
}
